/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */

#ifndef _JS_SHELL_H_
#define _JS_SHELL_H_

#include "js-scriptableobject.h"

/* Classes */
class JSShell: public JSScriptableObject {
    protected:
	static	jsBool_t	quitting;
        static  jsBool_t        silent;

    public:
	static	const jsString_t	className;
	static	JSShell		*global;

    protected:
	/* js methods */
	static	jsVal_t	print(JSContext *cx, JSScriptable *thisObj,
				int numArgs, jsVal_t *args,
				JSFunction *funObj);
	static	jsVal_t	version(JSContext *cx, JSScriptable *thisObj,
				int numArgs, jsVal_t *args,
				JSFunction *funObj);
	static	jsVal_t	load(JSContext *cx, JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
#ifdef PERSIST
        static  jsVal_t compile(JSContext *cx, JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t loadtime(JSContext *cx, JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
#endif

	static	void	p(jsString_t s);
	static	void	usage(jsString_t s);
	static	char	**processOptions(JSContext *cx, int argc, char **argv,
				int *pargc);
	static	void	processSource(JSContext *cx, jsString_t filename);

    public:
	static	void	defineClass(JSContext *cx);

	/* js methods */
	static	void	help(jsString_t s);
	static	void	quit();
	static	void	gc(JSContext *cx);
	static	void	sleep(int milliseconds);

	/* entry method */
#ifdef VX
	static	void	shell(int argc, char **argv);
#else
	static	void	main(int argc, char **argv);
#endif

	/* scriptable methods */
	jsString_t
		getClassName(JSContext *cx);
};

/* Procedures */
extern "C" {
int	main(int argc, char **argv);
} 

#endif /* _JS_SHELL_H_ */
